package kr.co.icontrols.ilp300_700.admin.setting;

import android.content.Context;
import android.content.Intent;
import android.graphics.Color;
import android.util.Log;
import android.view.Gravity;
import android.view.KeyEvent;
import android.widget.RelativeLayout;

import kr.co.icontrols.ilp300_700.MainActivity;
import kr.co.icontrols.ilp300_700.R;
import kr.co.icontrols.ilp300_700.ethernet.EthernetCtrl;
import kr.co.icontrols.ilp300_700.global.Configure.ConfigValKey;
import kr.co.icontrols.ilp300_700.global.Configure.ConfigValue;
import kr.co.icontrols.ilp300_700.global.Configure.SetValue;
import kr.co.icontrols.ilp300_700.global.DataClasses.POSITION;
import kr.co.icontrols.ilp300_700.global.Declare;
import kr.co.icontrols.ilp300_700.global.ID;
import kr.co.icontrols.wallpadsupport.WpadImageView;
import kr.co.icontrols.wallpadsupport.WpadScreen;
import kr.co.icontrols.wallpadsupport.WpadTextView;

public class AdminSet_Setting_IPExpansion extends WpadScreen {

    String TAG = "AdminSet_Setting_IPExpansion";

    boolean bLOG = true;   // true, false
    boolean bLOG_DEBUG = false;   // true, false
    boolean bLOG_INFO = true;   // true, false
    Context mContext;
    WpadImageView Image_Background;
    WpadTextView Text_Title;
    WpadTextView Text_Line_01_Item;
    WpadTextView Text_Line_02_Item;
    WpadTextView Text_Line_03_Item;
    WpadTextView Text_Line_04_Item;
    int TextColor_Normal = Color.WHITE;
    int TextColor_Highlight = Color.GREEN;
    int nFontSize_Instruction = 28;
    boolean bFontNonBold = false;
    boolean bFontBold = true;
    String strText_Title = "IP 대역 확장 설정";
    String strText_Line_01_Item = "1] 설정함";
    String strText_Line_02_Item = "2] 설정안함";
    String strText_Line_03_Item = "[경고]";
    String strText_Line_04_Item = "임의로 조작하지 마세요.";
    public AdminSet_Setting_IPExpansion(Context context, RelativeLayout layout) {
        super(context, layout);
        try {
            LOG("------------------ [START - AdminSet_Setting_IPExpansion] -------------------");

            mContext = context;
            Initialize();

            Image_Background = new WpadImageView(context, 0, Declare.DeviceInfo.getScreenSizeFullW(ConfigValue.DEVICE_MODELTYPE), Declare.DeviceInfo.getScreenSizeFullH(ConfigValue.DEVICE_MODELTYPE), R.drawable.bg_back, 0, ID.SCREENS.ADMINSET_SETTING_IPEXPANSION.ELEMENTS.IMAGES.BACKGROUND);
            ViewRegistration(layout, Image_Background, 0, 0);

            Text_Title = new WpadTextView(context, false, getPosition(ID.SCREENS.ADMINSET_SETTING_IPEXPANSION.ELEMENTS.TEXTS.TITLE).W, getPosition(ID.SCREENS.ADMINSET_SETTING_IPEXPANSION.ELEMENTS.TEXTS.TITLE).H, Gravity.CENTER, Color.WHITE, nFontSize_Instruction, bFontBold, ID.SCREENS.ADMINSET_SETTING_IPEXPANSION.ELEMENTS.TEXTS.TITLE);
            ViewRegistration(layout, Text_Title, getPosition(ID.SCREENS.ADMINSET_SETTING_IPEXPANSION.ELEMENTS.TEXTS.TITLE).X, getPosition(ID.SCREENS.ADMINSET_SETTING_IPEXPANSION.ELEMENTS.TEXTS.TITLE).Y);
            Text_Title.setText(strText_Title);

            Text_Line_01_Item = new WpadTextView(context, false, getPosition(ID.SCREENS.ADMINSET_SETTING_IPEXPANSION.ELEMENTS.TEXTS.LINE_01_Item).W, getPosition(ID.SCREENS.ADMINSET_SETTING_IPEXPANSION.ELEMENTS.TEXTS.LINE_01_Item).H, Gravity.LEFT, Color.WHITE, nFontSize_Instruction, bFontNonBold, ID.SCREENS.ADMINSET_SETTING_IPEXPANSION.ELEMENTS.TEXTS.LINE_01_Item);
            ViewRegistration(layout, Text_Line_01_Item, getPosition(ID.SCREENS.ADMINSET_SETTING_IPEXPANSION.ELEMENTS.TEXTS.LINE_01_Item).X, getPosition(ID.SCREENS.ADMINSET_SETTING_IPEXPANSION.ELEMENTS.TEXTS.LINE_01_Item).Y);
            Text_Line_01_Item.setText(strText_Line_01_Item);

            Text_Line_02_Item = new WpadTextView(context, false, getPosition(ID.SCREENS.ADMINSET_SETTING_IPEXPANSION.ELEMENTS.TEXTS.LINE_02_Item).W, getPosition(ID.SCREENS.ADMINSET_SETTING_IPEXPANSION.ELEMENTS.TEXTS.LINE_02_Item).H, Gravity.LEFT, Color.WHITE, nFontSize_Instruction, bFontNonBold, ID.SCREENS.ADMINSET_SETTING_IPEXPANSION.ELEMENTS.TEXTS.LINE_02_Item);
            ViewRegistration(layout, Text_Line_02_Item, getPosition(ID.SCREENS.ADMINSET_SETTING_IPEXPANSION.ELEMENTS.TEXTS.LINE_02_Item).X, getPosition(ID.SCREENS.ADMINSET_SETTING_IPEXPANSION.ELEMENTS.TEXTS.LINE_02_Item).Y);
            Text_Line_02_Item.setText(strText_Line_02_Item);

            Text_Line_03_Item = new WpadTextView(context, false, getPosition(ID.SCREENS.ADMINSET_SETTING_IPEXPANSION.ELEMENTS.TEXTS.LINE_03_Item).W, getPosition(ID.SCREENS.ADMINSET_SETTING_IPEXPANSION.ELEMENTS.TEXTS.LINE_03_Item).H, Gravity.CENTER, Color.RED, nFontSize_Instruction, bFontNonBold, ID.SCREENS.ADMINSET_SETTING_IPEXPANSION.ELEMENTS.TEXTS.LINE_03_Item);
            ViewRegistration(layout, Text_Line_03_Item, getPosition(ID.SCREENS.ADMINSET_SETTING_IPEXPANSION.ELEMENTS.TEXTS.LINE_03_Item).X, getPosition(ID.SCREENS.ADMINSET_SETTING_IPEXPANSION.ELEMENTS.TEXTS.LINE_03_Item).Y);
            Text_Line_03_Item.setText(strText_Line_03_Item);

            Text_Line_04_Item = new WpadTextView(context, false, getPosition(ID.SCREENS.ADMINSET_SETTING_IPEXPANSION.ELEMENTS.TEXTS.LINE_04_Item).W, getPosition(ID.SCREENS.ADMINSET_SETTING_IPEXPANSION.ELEMENTS.TEXTS.LINE_04_Item).H, Gravity.CENTER, Color.GREEN, nFontSize_Instruction, bFontNonBold, ID.SCREENS.ADMINSET_SETTING_IPEXPANSION.ELEMENTS.TEXTS.LINE_04_Item);
            ViewRegistration(layout, Text_Line_04_Item, getPosition(ID.SCREENS.ADMINSET_SETTING_IPEXPANSION.ELEMENTS.TEXTS.LINE_04_Item).X, getPosition(ID.SCREENS.ADMINSET_SETTING_IPEXPANSION.ELEMENTS.TEXTS.LINE_04_Item).Y);
            Text_Line_04_Item.setText(strText_Line_04_Item);

            ((MainActivity) mContext).setAutoScreenChange(ID.SCREENS.Main, MainActivity.nAdminScreenTimeout);
        } catch (Exception e) {
            Log.e(TAG, "[Exception] AdminSet_Setting_IPExpansion(Context context, RelativeLayout layout)");
            e.printStackTrace();
        }
    }

    private void LOG(String log) {
        if (bLOG) Log.v(TAG, log);
    }

    private void LOG_DEBUG(String log) {
        if (bLOG_DEBUG) Log.d(TAG, log);
    }

    private void LOG_INFO(String log) {
        if (bLOG_INFO) Log.i(TAG, log);
    }

    protected void Initialize() {
        try {
            LOG("[Initialize] ===== START =====");
            getIPExpansion();
        } catch (Exception e) {
            Log.e(TAG, "[Exception] Initialize()");
            e.printStackTrace();
        }
    }

    @Override
    protected void onClose() {
        try {
            LOG("------------------ [onClose - AdminSet_Setting_IPExpansion] -------------------");
        } catch (Exception e) {
            Log.e(TAG, "[Exception] onClose()");
            e.printStackTrace();
        }
        super.onClose();
    }

    @Override
    protected void onBrReceive(Intent intent) {
        try {
            LOG("[onBrReceive] Intent : " + intent);
        } catch (Exception e) {
            Log.e(TAG, "[Exception] onBrReceive(Intent intent)");
            e.printStackTrace();
        }
        super.onBrReceive(intent);
    }

    @Override
    protected void onKeyDown(int keyCode, KeyEvent event) {
        try {
//            LOG("[onKeyDown] keyCode [" + keyCode + "], event [" + event + "]");
            if (keyCode == Declare.Button.NUMBER_01) {
                // 연동함
                if (setIPExpansion(SetValue.TRUE)) {
                    MainActivity.mSound.PlayMent_lobby(R.raw.setting);
                    if (checkIPExpansion(SetValue.TRUE)) super.setChangeScreen(ID.SCREENS.Reboot);
                    else super.setChangeScreen(ID.SCREENS.AdminSet_Setting);
                } else {
                    MainActivity.mSound.PlayMent_lobby(R.raw.retryinput);
                }
            } else if (keyCode == Declare.Button.NUMBER_02) {
                // 연동안함
                if (setIPExpansion(SetValue.FALSE)) {
                    MainActivity.mSound.PlayMent_lobby(R.raw.setting);
                    if (checkIPExpansion(SetValue.FALSE)) super.setChangeScreen(ID.SCREENS.Reboot);
                    else super.setChangeScreen(ID.SCREENS.AdminSet_Setting);
                } else {
                    MainActivity.mSound.PlayMent_lobby(R.raw.retryinput);
                }
            } else if (keyCode == Declare.Button.CANCEL || keyCode == Declare.Button.TACT_CANCEL) {
                super.setChangeScreen(ID.SCREENS.AdminSet_Setting);
            }
        } catch (Exception e) {
            Log.e(TAG, "[Exception] onKeyDown(int keyCode, KeyEvent event)");
            e.printStackTrace();
        }
        super.onKeyDown(keyCode, event);
    }

    public POSITION getPosition(int nID) {
//        LOG("[getPosition] ===== START =====");
        POSITION position = new POSITION();
        position.SetPosition(0, 0, 480, 272);
        try {
            switch (nID) {
                case ID.SCREENS.ADMINSET_SETTING_IPEXPANSION.ELEMENTS.IMAGES.BACKGROUND:
                    position.SetPosition(0, 0, 480, 272);
                    return position;

                case ID.SCREENS.ADMINSET_SETTING_IPEXPANSION.ELEMENTS.TEXTS.TITLE:
                    position.SetPosition(0, 24, 480, 40);
                    return position;

                case ID.SCREENS.ADMINSET_SETTING_IPEXPANSION.ELEMENTS.TEXTS.LINE_01_Item:
                    position.SetPosition(30, 73, 420, 40);
                    return position;

                case ID.SCREENS.ADMINSET_SETTING_IPEXPANSION.ELEMENTS.TEXTS.LINE_02_Item:
                    position.SetPosition(30, 122, 420, 40);
                    return position;

                case ID.SCREENS.ADMINSET_SETTING_IPEXPANSION.ELEMENTS.TEXTS.LINE_03_Item:
                    position.SetPosition(0, 171, 480, 40);
                    return position;

                case ID.SCREENS.ADMINSET_SETTING_IPEXPANSION.ELEMENTS.TEXTS.LINE_04_Item:
                    position.SetPosition(0, 220, 480, 40);
                    return position;

                default:
                    return position;
            }
        } catch (Exception e) {
            Log.e(TAG, "[Exception] getPosition(int nID)");
            e.printStackTrace();
            return position;
        }
    }

    private boolean setIPExpansion(SetValue eSetValue) {
        try {
            LOG("[setIPExpansion] eSetValue [" + eSetValue + "]");
            ConfigValue.eIPExpansion = eSetValue;
            return MainActivity.ConfigDBManager.setData(Declare.DBInfo.TABLE_NAME_CONFIG, ConfigValKey.IPExpansion, ConfigValue.eIPExpansion);
        } catch (Exception e) {
            Log.e(TAG, "[Exception] setIPExpansion(SetValue eSetValue)");
            e.printStackTrace();
            return false;
        }
    }

    private boolean checkIPExpansion(SetValue eSetValue) {
        try {
            int nDong = Integer.parseInt(ConfigValue.strDevice_Dong);
            int nDong_Head = nDong / 100;
            String[] astrIPAddress = ConfigValue.strDeviceIPAddress.split("\\.");

            if (eSetValue == SetValue.TRUE) {
                if (nDong_Head != Integer.parseInt(astrIPAddress[0])) {
                    return EthernetCtrl.setDeviceIPAddressByBasicInfo(mContext, ConfigValue.strSitecode, ConfigValue.strDevice_Dong, ConfigValue.strDevice_ID);
                }
            } else {
                if (10 != Integer.parseInt(astrIPAddress[0])) {
                    return EthernetCtrl.setDeviceIPAddressByBasicInfo(mContext, ConfigValue.strSitecode, ConfigValue.strDevice_Dong, ConfigValue.strDevice_ID);
                }
            }
        } catch (Exception e) {
            Log.e(TAG, "[Exception] checkIPExpansion(SetValue eSetValue)");
            e.printStackTrace();
        }
        return false;
    }

    private void getIPExpansion() {
        try {
            if (ConfigValue.eIPExpansion == SetValue.TRUE) strText_Line_03_Item += " *설정중*";
            else strText_Line_03_Item += " *미설정중*";
        } catch (Exception e) {
            Log.e(TAG, "[Exception] getIPExpansion()");
            e.printStackTrace();
        }
    }


}